#version 330

/**
 * This first defined out variable of the fragment shader defines
 * with which color the fragment is rendered
 */
out vec4 fragment_color;

/** Input variable of texture coordinate from vertex shader */
in vec2 texCoord_from_vs;

/** Position texture of pass 1 */
uniform sampler2D gBufferPosition;

/** Normal texture of pass 1 */
uniform sampler2D gBufferNormal;

/** Color texture of pass 1 */
uniform sampler2D gBufferMaterial;

/** Ambient light color (I_amb): */
vec3 ambientColor = vec3(0.05, 0.05, 0.05);

// Structure for lights:
struct Light {
    vec3 position;
    vec3 color;
    float range;
};

// Predefine 100 point lights (since arrays must have a fixed size in GLSL):
uniform Light lights[100];

// Number of lights that should actually be used:
uniform int lightNum;

/**
 * The main function of the fragment shader, which is executed
 * for every fragment.
 */
void main()
{
    // TODO:
    // (2b) Read the textures (gBuffers) and use the values as attributes
    // for the lighting you implemented in immediateLighting.frag. You can
    // reuse most of your previous implementation:
    vec4 materialColorAndShininess = texture2D(gBufferMaterial, texCoord_from_vs);

    // ... Calculate Blinn-Phong Model ...

    // Set pixel color
    fragment_color = vec4(materialColorAndShininess.rgb, 1.0);
}
